"use strict";
var TemplateStore = (function () {
    function TemplateStore() {
        this.templates = {};
        this.caching = {};
        this.cachingUpdates = {};
    }
    TemplateStore.prototype.storeTemplate = function (id, template) {
        this.templates[id] = template;
        if (this.caching[id]) {
            this.cachingUpdates[id].forEach(function (callback) { return callback(true); });
            delete this.caching[id];
            delete this.cachingUpdates[id];
        }
    };
    TemplateStore.prototype.retrieveTemplate = function (id) {
        return this.templates[id];
    };
    TemplateStore.prototype.checkTemplateCached = function (id, callback) {
        var cached = !!this.templates[id];
        if (!cached) {
            if (!this.caching[id]) {
                this.caching[id] = true;
                callback(false);
            }
            else {
                this.cachingUpdates[id] = this.cachingUpdates[id] || [];
                this.cachingUpdates[id].push(callback);
            }
            return;
        }
        callback(true);
    };
    return TemplateStore;
}());
exports.TemplateStore = TemplateStore;
exports.templateStore = new TemplateStore();
//# sourceMappingURL=template-store.service.js.map