"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('angular2/core');
var http_1 = require('angular2/http');
var template_directive_1 = require('./template.directive');
var template_store_service_1 = require('./template-store.service');
var TemplateComponent = (function () {
    function TemplateComponent(el, vc, dcl, http) {
        this._local = true;
        this._elementRef = el;
        this._viewContainer = vc;
        this._dynamicComponentLoader = dcl;
        this._http = http;
    }
    Object.defineProperty(TemplateComponent.prototype, "context", {
        set: function (bindable) {
            this._context = bindable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TemplateComponent.prototype, "id", {
        set: function (id) {
            if (id) {
                this._local = true;
                this._view = this._viewContainer.createEmbeddedView(template_store_service_1.templateStore.retrieveTemplate(id));
                for (var key in this._context) {
                    //noinspection JSUnfilteredForInLoop
                    this._view.setLocal(key, this._context[key]);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TemplateComponent.prototype, "url", {
        set: function (url) {
            var _this = this;
            if (url) {
                template_store_service_1.templateStore.checkTemplateCached(url, function (available) {
                    if (available) {
                        _this.id = url;
                        return;
                    }
                    _this._local = false;
                    _this._http.get(url)
                        .map(function (res) { return res.text(); })
                        .subscribe(function (template) {
                        _this._dynamicComponentLoader.loadNextToLocation(TemplateComponent.generateComponent(template, url, _this._context), _this._elementRef);
                        setTimeout(function () {
                            _this.id = url;
                        });
                    }, function (err) {
                        throw err;
                    });
                });
            }
        },
        enumerable: true,
        configurable: true
    });
    TemplateComponent.generateComponent = function (template, url, context) {
        var contextString = "";
        for (var key in context) {
            //noinspection JSUnfilteredForInLoop
            contextString += "#" + key + "=\"" + key + "\" ";
        }
        var GeneratedTemplateComponent = (function () {
            function GeneratedTemplateComponent() {
            }
            GeneratedTemplateComponent = __decorate([
                core_1.Component({
                    selector: 'sui-template-generated',
                    template: "<template suiTemplate=\"" + url + "\" " + contextString + ">" + template + "</template>",
                    directives: [template_directive_1.TemplateDirective],
                    styles: [':host { display: none }']
                }), 
                __metadata('design:paramtypes', [])
            ], GeneratedTemplateComponent);
            return GeneratedTemplateComponent;
        }());
        return GeneratedTemplateComponent;
    };
    __decorate([
        core_1.HostBinding('class.local'), 
        __metadata('design:type', Boolean)
    ], TemplateComponent.prototype, "_local", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], TemplateComponent.prototype, "context", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String), 
        __metadata('design:paramtypes', [String])
    ], TemplateComponent.prototype, "id", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String), 
        __metadata('design:paramtypes', [String])
    ], TemplateComponent.prototype, "url", null);
    TemplateComponent = __decorate([
        core_1.Component({
            selector: 'sui-template',
            template: '',
            styles: [":host.local { display: none; }"]
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef, core_1.ViewContainerRef, core_1.DynamicComponentLoader, http_1.Http])
    ], TemplateComponent);
    return TemplateComponent;
}());
exports.TemplateComponent = TemplateComponent;
//# sourceMappingURL=template.component.js.map